extension Nullables<T> on T? {
  bool get isNull => this == null;

  bool get isNotNull => !isNull;

  T? get orNull => this;

  T or(T backup) => this ?? backup;

  Nullable<T> get toNullable => Nullable(this);
}

extension StringX on String? {
  String get orEmptyString => this ?? '';

  bool get isNotNullOrEmpty => isNotNull && this!.isNotEmpty;

  bool get isNullOrEmpty => isNull || this!.isEmpty;
}

extension IterableX on Iterable? {
  bool get isNotNullOrEmpty => isNotNull && this!.isNotEmpty;

  bool get isNullOrEmpty => isNull || this!.isEmpty;
}

extension NullableX<T> on Nullable<T>? {
  T? copyNullableOr(T? backup) =>  isNotNull ? this?.value : backup;
}

class Nullable<T> {
  final T? value;

  const Nullable(this.value);

  T? get orNull => value;
}